<!-- ImporterDialog.svelte -->
<script lang="ts">
  import { importCharacter } from '../module/importer/importer'
  import { ImportOptions } from '../module/importer/importOptions';
  import { getGame } from '../module/utils';

  export var actors: Actor[] = []
  export var foundryApp: Application;

  let xmlInput: HTMLInputElement;

  let updateActor: boolean;

  let selectedActorId = ''
  let options = new ImportOptions()
  const game = getGame()

  async function handleClick() {
    if (xmlInput.files && xmlInput.files.length > 0 && xmlInput.files[0]) {
      let file: File = xmlInput.files[0];

      try {
        const xmlData = await readFileAsText(file);

        const actorId = selectedActorId != '' ? selectedActorId : undefined
        await importCharacter(xmlData, actorId, options)
        await foundryApp.close()
        
      } catch (e) {
        console.error("Error occurred reading file: ", e);
        await ChatMessage.create({
          user: game.userId,
          content: game.i18n.localize('DSA.characterImportFailed')
        });
      }
    }
  }

  function handleDragDrop(event: DragEvent) {
    if (!event.dataTransfer?.files || event.dataTransfer.files.length < 1) { // Check if we got a file
      // No file, abort
      console.debug("Registered DragEvent without file present.", event);
      return;
    }

    const file = event.dataTransfer.files[0];

    // Validate file extension. Users will try it, I guarantee...
    if (!file.name.endsWith(".xml")) {
      console.warn("Can only import XML files.");
      return;
    }

    xmlInput.files = event.dataTransfer.files;
  }

  function handleCancel() {
    console.info("Character import cancelled by user.")
    foundryApp.close();
  }

  async function readFileAsText(file: File): Promise<string> {
    return new Promise<string>((resolve, reject) => {
      const reader = new FileReader();
      reader.onload = () => {
        const result = reader.result;
        if (!result) reject(new Error('Failed to read file'));
        resolve(typeof result === 'string' ? result : new TextDecoder().decode(result as ArrayBuffer));
      };
      reader.onerror = (event) => reject(event.target?.error || new Error('An error occurred while reading the file'));
      reader.readAsArrayBuffer(file);
    });
  }
</script>

<!-- Drop container around everything for easy file dropping -->
<div id='character-file-drop-container' on:drop={handleDragDrop} style='min-width: 20vw; max-width: 40vw;'>

  <p>{game.i18n.localize('DSA.characterImportExplainer')}</p>
  <br>

  <form>
    <div>
      <p>
        <label for='character-file'>{game.i18n.localize('DSA.dropHeldenXmlHere')}</label><br>
        <input type='file' accept='.xml' name='character-file' id='character-file' bind:this={xmlInput} style='width: max-content;' />
      </p>
    </div>
  </form>
  <br>

  <label>
    <input type=checkbox bind:checked={updateActor}>
    {game.i18n.localize('DSA.updateCharacter')}
  </label>
  <select bind:value={selectedActorId} disabled='{!updateActor}'>
    <option value="" selected>None</option>
    {#each actors as actor}
      <option value={actor.id}>{actor.name}</option>
    {/each}
  </select>
  <br>

  <label>
    <input type=checkbox bind:checked={options.importEquipment}>
    {game.i18n.localize('DSA.checkImportEquipment')}
  </label>
  <br>
  <label>
    <input type=checkbox bind:checked={options.showCharacterAfterImport}>
    {game.i18n.localize('DSA.showCharacterAfterImport')}
  </label>
  <div class="dialog">
    <div class="dialog-buttons">
      <button on:click={handleClick}><i class='fas fa-file-import' /> {game.i18n.localize('DSA.btnImportCharacter')}</button>
      <button on:click={handleCancel}><i class='fas fa-times' /> {game.i18n.localize('DSA.btnCancelImportCharacter')}</button>
    </div>
  </div>

</div>